/**
 * Autogenerated by Thrift Compiler (1.0.0-dev)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package jayeson.vodds.service.cms.thrift;

import org.apache.thrift.scheme.IScheme;
import org.apache.thrift.scheme.SchemeFactory;
import org.apache.thrift.scheme.StandardScheme;

import org.apache.thrift.scheme.TupleScheme;
import org.apache.thrift.protocol.TTupleProtocol;
import org.apache.thrift.protocol.TProtocolException;
import org.apache.thrift.EncodingUtils;
import org.apache.thrift.TException;
import org.apache.thrift.async.AsyncMethodCallback;
import org.apache.thrift.server.AbstractNonblockingServer.*;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import java.util.BitSet;
import java.nio.ByteBuffer;
import java.util.Arrays;
import javax.annotation.Generated;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings({"cast", "rawtypes", "serial", "unchecked"})
@Generated(value = "Autogenerated by Thrift Compiler (1.0.0-dev)", date = "2022-4-26")
public class ThriftCreditRequestInfo implements org.apache.thrift.TBase<ThriftCreditRequestInfo, ThriftCreditRequestInfo._Fields>, java.io.Serializable, Cloneable, Comparable<ThriftCreditRequestInfo> {
  private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("ThriftCreditRequestInfo");

  private static final org.apache.thrift.protocol.TField O_TYPE_FIELD_DESC = new org.apache.thrift.protocol.TField("oType", org.apache.thrift.protocol.TType.I32, (short)1);
  private static final org.apache.thrift.protocol.TField T_TYPE_FIELD_DESC = new org.apache.thrift.protocol.TField("tType", org.apache.thrift.protocol.TType.I32, (short)2);
  private static final org.apache.thrift.protocol.TField SERVICE_ID_FIELD_DESC = new org.apache.thrift.protocol.TField("serviceId", org.apache.thrift.protocol.TType.STRING, (short)3);
  private static final org.apache.thrift.protocol.TField USER_ID_FIELD_DESC = new org.apache.thrift.protocol.TField("userId", org.apache.thrift.protocol.TType.I64, (short)4);
  private static final org.apache.thrift.protocol.TField MATCH_ID_FIELD_DESC = new org.apache.thrift.protocol.TField("matchId", org.apache.thrift.protocol.TType.STRING, (short)5);
  private static final org.apache.thrift.protocol.TField SPORT_TYPE_FIELD_DESC = new org.apache.thrift.protocol.TField("sportType", org.apache.thrift.protocol.TType.STRING, (short)6);
  private static final org.apache.thrift.protocol.TField ORDER_STATUS_FIELD_DESC = new org.apache.thrift.protocol.TField("orderStatus", org.apache.thrift.protocol.TType.STRING, (short)7);
  private static final org.apache.thrift.protocol.TField EXECUTION_STAGE_FIELD_DESC = new org.apache.thrift.protocol.TField("executionStage", org.apache.thrift.protocol.TType.STRING, (short)8);
  private static final org.apache.thrift.protocol.TField START_TIME_FIELD_DESC = new org.apache.thrift.protocol.TField("startTime", org.apache.thrift.protocol.TType.I64, (short)9);
  private static final org.apache.thrift.protocol.TField ORIGINAL_STAKE_FIELD_DESC = new org.apache.thrift.protocol.TField("originalStake", org.apache.thrift.protocol.TType.DOUBLE, (short)10);
  private static final org.apache.thrift.protocol.TField REQUEST_JSON_FIELD_DESC = new org.apache.thrift.protocol.TField("requestJson", org.apache.thrift.protocol.TType.STRING, (short)11);

  private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
  static {
    schemes.put(StandardScheme.class, new ThriftCreditRequestInfoStandardSchemeFactory());
    schemes.put(TupleScheme.class, new ThriftCreditRequestInfoTupleSchemeFactory());
  }

  /**
   * 
   * @see ThriftOrderType
   */
  public ThriftOrderType oType; // required
  /**
   * 
   * @see ThriftTransactionType
   */
  public ThriftTransactionType tType; // required
  public String serviceId; // required
  public long userId; // required
  public String matchId; // required
  public String sportType; // required
  public String orderStatus; // required
  public String executionStage; // required
  public long startTime; // required
  public double originalStake; // required
  public String requestJson; // required

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements org.apache.thrift.TFieldIdEnum {
    /**
     * 
     * @see ThriftOrderType
     */
    O_TYPE((short)1, "oType"),
    /**
     * 
     * @see ThriftTransactionType
     */
    T_TYPE((short)2, "tType"),
    SERVICE_ID((short)3, "serviceId"),
    USER_ID((short)4, "userId"),
    MATCH_ID((short)5, "matchId"),
    SPORT_TYPE((short)6, "sportType"),
    ORDER_STATUS((short)7, "orderStatus"),
    EXECUTION_STAGE((short)8, "executionStage"),
    START_TIME((short)9, "startTime"),
    ORIGINAL_STAKE((short)10, "originalStake"),
    REQUEST_JSON((short)11, "requestJson");

    private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

    static {
      for (_Fields field : EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // O_TYPE
          return O_TYPE;
        case 2: // T_TYPE
          return T_TYPE;
        case 3: // SERVICE_ID
          return SERVICE_ID;
        case 4: // USER_ID
          return USER_ID;
        case 5: // MATCH_ID
          return MATCH_ID;
        case 6: // SPORT_TYPE
          return SPORT_TYPE;
        case 7: // ORDER_STATUS
          return ORDER_STATUS;
        case 8: // EXECUTION_STAGE
          return EXECUTION_STAGE;
        case 9: // START_TIME
          return START_TIME;
        case 10: // ORIGINAL_STAKE
          return ORIGINAL_STAKE;
        case 11: // REQUEST_JSON
          return REQUEST_JSON;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    public static _Fields findByName(String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final String _fieldName;

    _Fields(short thriftId, String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final int __USERID_ISSET_ID = 0;
  private static final int __STARTTIME_ISSET_ID = 1;
  private static final int __ORIGINALSTAKE_ISSET_ID = 2;
  private byte __isset_bitfield = 0;
  public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
  static {
    Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.O_TYPE, new org.apache.thrift.meta_data.FieldMetaData("oType", org.apache.thrift.TFieldRequirementType.REQUIRED, 
        new org.apache.thrift.meta_data.EnumMetaData(org.apache.thrift.protocol.TType.ENUM, ThriftOrderType.class)));
    tmpMap.put(_Fields.T_TYPE, new org.apache.thrift.meta_data.FieldMetaData("tType", org.apache.thrift.TFieldRequirementType.REQUIRED, 
        new org.apache.thrift.meta_data.EnumMetaData(org.apache.thrift.protocol.TType.ENUM, ThriftTransactionType.class)));
    tmpMap.put(_Fields.SERVICE_ID, new org.apache.thrift.meta_data.FieldMetaData("serviceId", org.apache.thrift.TFieldRequirementType.REQUIRED, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    tmpMap.put(_Fields.USER_ID, new org.apache.thrift.meta_data.FieldMetaData("userId", org.apache.thrift.TFieldRequirementType.REQUIRED, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64)));
    tmpMap.put(_Fields.MATCH_ID, new org.apache.thrift.meta_data.FieldMetaData("matchId", org.apache.thrift.TFieldRequirementType.REQUIRED, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    tmpMap.put(_Fields.SPORT_TYPE, new org.apache.thrift.meta_data.FieldMetaData("sportType", org.apache.thrift.TFieldRequirementType.REQUIRED, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    tmpMap.put(_Fields.ORDER_STATUS, new org.apache.thrift.meta_data.FieldMetaData("orderStatus", org.apache.thrift.TFieldRequirementType.REQUIRED, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    tmpMap.put(_Fields.EXECUTION_STAGE, new org.apache.thrift.meta_data.FieldMetaData("executionStage", org.apache.thrift.TFieldRequirementType.DEFAULT, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    tmpMap.put(_Fields.START_TIME, new org.apache.thrift.meta_data.FieldMetaData("startTime", org.apache.thrift.TFieldRequirementType.REQUIRED, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.I64)));
    tmpMap.put(_Fields.ORIGINAL_STAKE, new org.apache.thrift.meta_data.FieldMetaData("originalStake", org.apache.thrift.TFieldRequirementType.DEFAULT, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.DOUBLE)));
    tmpMap.put(_Fields.REQUEST_JSON, new org.apache.thrift.meta_data.FieldMetaData("requestJson", org.apache.thrift.TFieldRequirementType.REQUIRED, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    metaDataMap = Collections.unmodifiableMap(tmpMap);
    org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(ThriftCreditRequestInfo.class, metaDataMap);
  }

  public ThriftCreditRequestInfo() {
  }

  public ThriftCreditRequestInfo(
    ThriftOrderType oType,
    ThriftTransactionType tType,
    String serviceId,
    long userId,
    String matchId,
    String sportType,
    String orderStatus,
    String executionStage,
    long startTime,
    double originalStake,
    String requestJson)
  {
    this();
    this.oType = oType;
    this.tType = tType;
    this.serviceId = serviceId;
    this.userId = userId;
    setUserIdIsSet(true);
    this.matchId = matchId;
    this.sportType = sportType;
    this.orderStatus = orderStatus;
    this.executionStage = executionStage;
    this.startTime = startTime;
    setStartTimeIsSet(true);
    this.originalStake = originalStake;
    setOriginalStakeIsSet(true);
    this.requestJson = requestJson;
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public ThriftCreditRequestInfo(ThriftCreditRequestInfo other) {
    __isset_bitfield = other.__isset_bitfield;
    if (other.isSetOType()) {
      this.oType = other.oType;
    }
    if (other.isSetTType()) {
      this.tType = other.tType;
    }
    if (other.isSetServiceId()) {
      this.serviceId = other.serviceId;
    }
    this.userId = other.userId;
    if (other.isSetMatchId()) {
      this.matchId = other.matchId;
    }
    if (other.isSetSportType()) {
      this.sportType = other.sportType;
    }
    if (other.isSetOrderStatus()) {
      this.orderStatus = other.orderStatus;
    }
    if (other.isSetExecutionStage()) {
      this.executionStage = other.executionStage;
    }
    this.startTime = other.startTime;
    this.originalStake = other.originalStake;
    if (other.isSetRequestJson()) {
      this.requestJson = other.requestJson;
    }
  }

  public ThriftCreditRequestInfo deepCopy() {
    return new ThriftCreditRequestInfo(this);
  }

  @Override
  public void clear() {
    this.oType = null;
    this.tType = null;
    this.serviceId = null;
    setUserIdIsSet(false);
    this.userId = 0;
    this.matchId = null;
    this.sportType = null;
    this.orderStatus = null;
    this.executionStage = null;
    setStartTimeIsSet(false);
    this.startTime = 0;
    setOriginalStakeIsSet(false);
    this.originalStake = 0.0;
    this.requestJson = null;
  }

  /**
   * 
   * @see ThriftOrderType
   */
  public ThriftOrderType getOType() {
    return this.oType;
  }

  /**
   * 
   * @see ThriftOrderType
   */
  public ThriftCreditRequestInfo setOType(ThriftOrderType oType) {
    this.oType = oType;
    return this;
  }

  public void unsetOType() {
    this.oType = null;
  }

  /** Returns true if field oType is set (has been assigned a value) and false otherwise */
  public boolean isSetOType() {
    return this.oType != null;
  }

  public void setOTypeIsSet(boolean value) {
    if (!value) {
      this.oType = null;
    }
  }

  /**
   * 
   * @see ThriftTransactionType
   */
  public ThriftTransactionType getTType() {
    return this.tType;
  }

  /**
   * 
   * @see ThriftTransactionType
   */
  public ThriftCreditRequestInfo setTType(ThriftTransactionType tType) {
    this.tType = tType;
    return this;
  }

  public void unsetTType() {
    this.tType = null;
  }

  /** Returns true if field tType is set (has been assigned a value) and false otherwise */
  public boolean isSetTType() {
    return this.tType != null;
  }

  public void setTTypeIsSet(boolean value) {
    if (!value) {
      this.tType = null;
    }
  }

  public String getServiceId() {
    return this.serviceId;
  }

  public ThriftCreditRequestInfo setServiceId(String serviceId) {
    this.serviceId = serviceId;
    return this;
  }

  public void unsetServiceId() {
    this.serviceId = null;
  }

  /** Returns true if field serviceId is set (has been assigned a value) and false otherwise */
  public boolean isSetServiceId() {
    return this.serviceId != null;
  }

  public void setServiceIdIsSet(boolean value) {
    if (!value) {
      this.serviceId = null;
    }
  }

  public long getUserId() {
    return this.userId;
  }

  public ThriftCreditRequestInfo setUserId(long userId) {
    this.userId = userId;
    setUserIdIsSet(true);
    return this;
  }

  public void unsetUserId() {
    __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __USERID_ISSET_ID);
  }

  /** Returns true if field userId is set (has been assigned a value) and false otherwise */
  public boolean isSetUserId() {
    return EncodingUtils.testBit(__isset_bitfield, __USERID_ISSET_ID);
  }

  public void setUserIdIsSet(boolean value) {
    __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __USERID_ISSET_ID, value);
  }

  public String getMatchId() {
    return this.matchId;
  }

  public ThriftCreditRequestInfo setMatchId(String matchId) {
    this.matchId = matchId;
    return this;
  }

  public void unsetMatchId() {
    this.matchId = null;
  }

  /** Returns true if field matchId is set (has been assigned a value) and false otherwise */
  public boolean isSetMatchId() {
    return this.matchId != null;
  }

  public void setMatchIdIsSet(boolean value) {
    if (!value) {
      this.matchId = null;
    }
  }

  public String getSportType() {
    return this.sportType;
  }

  public ThriftCreditRequestInfo setSportType(String sportType) {
    this.sportType = sportType;
    return this;
  }

  public void unsetSportType() {
    this.sportType = null;
  }

  /** Returns true if field sportType is set (has been assigned a value) and false otherwise */
  public boolean isSetSportType() {
    return this.sportType != null;
  }

  public void setSportTypeIsSet(boolean value) {
    if (!value) {
      this.sportType = null;
    }
  }

  public String getOrderStatus() {
    return this.orderStatus;
  }

  public ThriftCreditRequestInfo setOrderStatus(String orderStatus) {
    this.orderStatus = orderStatus;
    return this;
  }

  public void unsetOrderStatus() {
    this.orderStatus = null;
  }

  /** Returns true if field orderStatus is set (has been assigned a value) and false otherwise */
  public boolean isSetOrderStatus() {
    return this.orderStatus != null;
  }

  public void setOrderStatusIsSet(boolean value) {
    if (!value) {
      this.orderStatus = null;
    }
  }

  public String getExecutionStage() {
    return this.executionStage;
  }

  public ThriftCreditRequestInfo setExecutionStage(String executionStage) {
    this.executionStage = executionStage;
    return this;
  }

  public void unsetExecutionStage() {
    this.executionStage = null;
  }

  /** Returns true if field executionStage is set (has been assigned a value) and false otherwise */
  public boolean isSetExecutionStage() {
    return this.executionStage != null;
  }

  public void setExecutionStageIsSet(boolean value) {
    if (!value) {
      this.executionStage = null;
    }
  }

  public long getStartTime() {
    return this.startTime;
  }

  public ThriftCreditRequestInfo setStartTime(long startTime) {
    this.startTime = startTime;
    setStartTimeIsSet(true);
    return this;
  }

  public void unsetStartTime() {
    __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __STARTTIME_ISSET_ID);
  }

  /** Returns true if field startTime is set (has been assigned a value) and false otherwise */
  public boolean isSetStartTime() {
    return EncodingUtils.testBit(__isset_bitfield, __STARTTIME_ISSET_ID);
  }

  public void setStartTimeIsSet(boolean value) {
    __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __STARTTIME_ISSET_ID, value);
  }

  public double getOriginalStake() {
    return this.originalStake;
  }

  public ThriftCreditRequestInfo setOriginalStake(double originalStake) {
    this.originalStake = originalStake;
    setOriginalStakeIsSet(true);
    return this;
  }

  public void unsetOriginalStake() {
    __isset_bitfield = EncodingUtils.clearBit(__isset_bitfield, __ORIGINALSTAKE_ISSET_ID);
  }

  /** Returns true if field originalStake is set (has been assigned a value) and false otherwise */
  public boolean isSetOriginalStake() {
    return EncodingUtils.testBit(__isset_bitfield, __ORIGINALSTAKE_ISSET_ID);
  }

  public void setOriginalStakeIsSet(boolean value) {
    __isset_bitfield = EncodingUtils.setBit(__isset_bitfield, __ORIGINALSTAKE_ISSET_ID, value);
  }

  public String getRequestJson() {
    return this.requestJson;
  }

  public ThriftCreditRequestInfo setRequestJson(String requestJson) {
    this.requestJson = requestJson;
    return this;
  }

  public void unsetRequestJson() {
    this.requestJson = null;
  }

  /** Returns true if field requestJson is set (has been assigned a value) and false otherwise */
  public boolean isSetRequestJson() {
    return this.requestJson != null;
  }

  public void setRequestJsonIsSet(boolean value) {
    if (!value) {
      this.requestJson = null;
    }
  }

  public void setFieldValue(_Fields field, Object value) {
    switch (field) {
    case O_TYPE:
      if (value == null) {
        unsetOType();
      } else {
        setOType((ThriftOrderType)value);
      }
      break;

    case T_TYPE:
      if (value == null) {
        unsetTType();
      } else {
        setTType((ThriftTransactionType)value);
      }
      break;

    case SERVICE_ID:
      if (value == null) {
        unsetServiceId();
      } else {
        setServiceId((String)value);
      }
      break;

    case USER_ID:
      if (value == null) {
        unsetUserId();
      } else {
        setUserId((Long)value);
      }
      break;

    case MATCH_ID:
      if (value == null) {
        unsetMatchId();
      } else {
        setMatchId((String)value);
      }
      break;

    case SPORT_TYPE:
      if (value == null) {
        unsetSportType();
      } else {
        setSportType((String)value);
      }
      break;

    case ORDER_STATUS:
      if (value == null) {
        unsetOrderStatus();
      } else {
        setOrderStatus((String)value);
      }
      break;

    case EXECUTION_STAGE:
      if (value == null) {
        unsetExecutionStage();
      } else {
        setExecutionStage((String)value);
      }
      break;

    case START_TIME:
      if (value == null) {
        unsetStartTime();
      } else {
        setStartTime((Long)value);
      }
      break;

    case ORIGINAL_STAKE:
      if (value == null) {
        unsetOriginalStake();
      } else {
        setOriginalStake((Double)value);
      }
      break;

    case REQUEST_JSON:
      if (value == null) {
        unsetRequestJson();
      } else {
        setRequestJson((String)value);
      }
      break;

    }
  }

  public Object getFieldValue(_Fields field) {
    switch (field) {
    case O_TYPE:
      return getOType();

    case T_TYPE:
      return getTType();

    case SERVICE_ID:
      return getServiceId();

    case USER_ID:
      return Long.valueOf(getUserId());

    case MATCH_ID:
      return getMatchId();

    case SPORT_TYPE:
      return getSportType();

    case ORDER_STATUS:
      return getOrderStatus();

    case EXECUTION_STAGE:
      return getExecutionStage();

    case START_TIME:
      return Long.valueOf(getStartTime());

    case ORIGINAL_STAKE:
      return Double.valueOf(getOriginalStake());

    case REQUEST_JSON:
      return getRequestJson();

    }
    throw new IllegalStateException();
  }

  /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    if (field == null) {
      throw new IllegalArgumentException();
    }

    switch (field) {
    case O_TYPE:
      return isSetOType();
    case T_TYPE:
      return isSetTType();
    case SERVICE_ID:
      return isSetServiceId();
    case USER_ID:
      return isSetUserId();
    case MATCH_ID:
      return isSetMatchId();
    case SPORT_TYPE:
      return isSetSportType();
    case ORDER_STATUS:
      return isSetOrderStatus();
    case EXECUTION_STAGE:
      return isSetExecutionStage();
    case START_TIME:
      return isSetStartTime();
    case ORIGINAL_STAKE:
      return isSetOriginalStake();
    case REQUEST_JSON:
      return isSetRequestJson();
    }
    throw new IllegalStateException();
  }

  @Override
  public boolean equals(Object that) {
    if (that == null)
      return false;
    if (that instanceof ThriftCreditRequestInfo)
      return this.equals((ThriftCreditRequestInfo)that);
    return false;
  }

  public boolean equals(ThriftCreditRequestInfo that) {
    if (that == null)
      return false;

    boolean this_present_oType = true && this.isSetOType();
    boolean that_present_oType = true && that.isSetOType();
    if (this_present_oType || that_present_oType) {
      if (!(this_present_oType && that_present_oType))
        return false;
      if (!this.oType.equals(that.oType))
        return false;
    }

    boolean this_present_tType = true && this.isSetTType();
    boolean that_present_tType = true && that.isSetTType();
    if (this_present_tType || that_present_tType) {
      if (!(this_present_tType && that_present_tType))
        return false;
      if (!this.tType.equals(that.tType))
        return false;
    }

    boolean this_present_serviceId = true && this.isSetServiceId();
    boolean that_present_serviceId = true && that.isSetServiceId();
    if (this_present_serviceId || that_present_serviceId) {
      if (!(this_present_serviceId && that_present_serviceId))
        return false;
      if (!this.serviceId.equals(that.serviceId))
        return false;
    }

    boolean this_present_userId = true;
    boolean that_present_userId = true;
    if (this_present_userId || that_present_userId) {
      if (!(this_present_userId && that_present_userId))
        return false;
      if (this.userId != that.userId)
        return false;
    }

    boolean this_present_matchId = true && this.isSetMatchId();
    boolean that_present_matchId = true && that.isSetMatchId();
    if (this_present_matchId || that_present_matchId) {
      if (!(this_present_matchId && that_present_matchId))
        return false;
      if (!this.matchId.equals(that.matchId))
        return false;
    }

    boolean this_present_sportType = true && this.isSetSportType();
    boolean that_present_sportType = true && that.isSetSportType();
    if (this_present_sportType || that_present_sportType) {
      if (!(this_present_sportType && that_present_sportType))
        return false;
      if (!this.sportType.equals(that.sportType))
        return false;
    }

    boolean this_present_orderStatus = true && this.isSetOrderStatus();
    boolean that_present_orderStatus = true && that.isSetOrderStatus();
    if (this_present_orderStatus || that_present_orderStatus) {
      if (!(this_present_orderStatus && that_present_orderStatus))
        return false;
      if (!this.orderStatus.equals(that.orderStatus))
        return false;
    }

    boolean this_present_executionStage = true && this.isSetExecutionStage();
    boolean that_present_executionStage = true && that.isSetExecutionStage();
    if (this_present_executionStage || that_present_executionStage) {
      if (!(this_present_executionStage && that_present_executionStage))
        return false;
      if (!this.executionStage.equals(that.executionStage))
        return false;
    }

    boolean this_present_startTime = true;
    boolean that_present_startTime = true;
    if (this_present_startTime || that_present_startTime) {
      if (!(this_present_startTime && that_present_startTime))
        return false;
      if (this.startTime != that.startTime)
        return false;
    }

    boolean this_present_originalStake = true;
    boolean that_present_originalStake = true;
    if (this_present_originalStake || that_present_originalStake) {
      if (!(this_present_originalStake && that_present_originalStake))
        return false;
      if (this.originalStake != that.originalStake)
        return false;
    }

    boolean this_present_requestJson = true && this.isSetRequestJson();
    boolean that_present_requestJson = true && that.isSetRequestJson();
    if (this_present_requestJson || that_present_requestJson) {
      if (!(this_present_requestJson && that_present_requestJson))
        return false;
      if (!this.requestJson.equals(that.requestJson))
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    List<Object> list = new ArrayList<Object>();

    boolean present_oType = true && (isSetOType());
    list.add(present_oType);
    if (present_oType)
      list.add(oType.getValue());

    boolean present_tType = true && (isSetTType());
    list.add(present_tType);
    if (present_tType)
      list.add(tType.getValue());

    boolean present_serviceId = true && (isSetServiceId());
    list.add(present_serviceId);
    if (present_serviceId)
      list.add(serviceId);

    boolean present_userId = true;
    list.add(present_userId);
    if (present_userId)
      list.add(userId);

    boolean present_matchId = true && (isSetMatchId());
    list.add(present_matchId);
    if (present_matchId)
      list.add(matchId);

    boolean present_sportType = true && (isSetSportType());
    list.add(present_sportType);
    if (present_sportType)
      list.add(sportType);

    boolean present_orderStatus = true && (isSetOrderStatus());
    list.add(present_orderStatus);
    if (present_orderStatus)
      list.add(orderStatus);

    boolean present_executionStage = true && (isSetExecutionStage());
    list.add(present_executionStage);
    if (present_executionStage)
      list.add(executionStage);

    boolean present_startTime = true;
    list.add(present_startTime);
    if (present_startTime)
      list.add(startTime);

    boolean present_originalStake = true;
    list.add(present_originalStake);
    if (present_originalStake)
      list.add(originalStake);

    boolean present_requestJson = true && (isSetRequestJson());
    list.add(present_requestJson);
    if (present_requestJson)
      list.add(requestJson);

    return list.hashCode();
  }

  @Override
  public int compareTo(ThriftCreditRequestInfo other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;

    lastComparison = Boolean.valueOf(isSetOType()).compareTo(other.isSetOType());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetOType()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.oType, other.oType);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetTType()).compareTo(other.isSetTType());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetTType()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.tType, other.tType);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetServiceId()).compareTo(other.isSetServiceId());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetServiceId()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.serviceId, other.serviceId);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetUserId()).compareTo(other.isSetUserId());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetUserId()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.userId, other.userId);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetMatchId()).compareTo(other.isSetMatchId());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetMatchId()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.matchId, other.matchId);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetSportType()).compareTo(other.isSetSportType());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetSportType()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.sportType, other.sportType);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetOrderStatus()).compareTo(other.isSetOrderStatus());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetOrderStatus()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.orderStatus, other.orderStatus);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetExecutionStage()).compareTo(other.isSetExecutionStage());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetExecutionStage()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.executionStage, other.executionStage);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetStartTime()).compareTo(other.isSetStartTime());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetStartTime()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.startTime, other.startTime);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetOriginalStake()).compareTo(other.isSetOriginalStake());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetOriginalStake()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.originalStake, other.originalStake);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetRequestJson()).compareTo(other.isSetRequestJson());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetRequestJson()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.requestJson, other.requestJson);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  public _Fields fieldForId(int fieldId) {
    return _Fields.findByThriftId(fieldId);
  }

  public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
    schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
  }

  public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
    schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder("ThriftCreditRequestInfo(");
    boolean first = true;

    sb.append("oType:");
    if (this.oType == null) {
      sb.append("null");
    } else {
      sb.append(this.oType);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("tType:");
    if (this.tType == null) {
      sb.append("null");
    } else {
      sb.append(this.tType);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("serviceId:");
    if (this.serviceId == null) {
      sb.append("null");
    } else {
      sb.append(this.serviceId);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("userId:");
    sb.append(this.userId);
    first = false;
    if (!first) sb.append(", ");
    sb.append("matchId:");
    if (this.matchId == null) {
      sb.append("null");
    } else {
      sb.append(this.matchId);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("sportType:");
    if (this.sportType == null) {
      sb.append("null");
    } else {
      sb.append(this.sportType);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("orderStatus:");
    if (this.orderStatus == null) {
      sb.append("null");
    } else {
      sb.append(this.orderStatus);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("executionStage:");
    if (this.executionStage == null) {
      sb.append("null");
    } else {
      sb.append(this.executionStage);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("startTime:");
    sb.append(this.startTime);
    first = false;
    if (!first) sb.append(", ");
    sb.append("originalStake:");
    sb.append(this.originalStake);
    first = false;
    if (!first) sb.append(", ");
    sb.append("requestJson:");
    if (this.requestJson == null) {
      sb.append("null");
    } else {
      sb.append(this.requestJson);
    }
    first = false;
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws org.apache.thrift.TException {
    // check for required fields
    if (oType == null) {
      throw new org.apache.thrift.protocol.TProtocolException("Required field 'oType' was not present! Struct: " + toString());
    }
    if (tType == null) {
      throw new org.apache.thrift.protocol.TProtocolException("Required field 'tType' was not present! Struct: " + toString());
    }
    if (serviceId == null) {
      throw new org.apache.thrift.protocol.TProtocolException("Required field 'serviceId' was not present! Struct: " + toString());
    }
    // alas, we cannot check 'userId' because it's a primitive and you chose the non-beans generator.
    if (matchId == null) {
      throw new org.apache.thrift.protocol.TProtocolException("Required field 'matchId' was not present! Struct: " + toString());
    }
    if (sportType == null) {
      throw new org.apache.thrift.protocol.TProtocolException("Required field 'sportType' was not present! Struct: " + toString());
    }
    if (orderStatus == null) {
      throw new org.apache.thrift.protocol.TProtocolException("Required field 'orderStatus' was not present! Struct: " + toString());
    }
    // alas, we cannot check 'startTime' because it's a primitive and you chose the non-beans generator.
    if (requestJson == null) {
      throw new org.apache.thrift.protocol.TProtocolException("Required field 'requestJson' was not present! Struct: " + toString());
    }
    // check for sub-struct validity
  }

  private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
    try {
      write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
    try {
      // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
      __isset_bitfield = 0;
      read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private static class ThriftCreditRequestInfoStandardSchemeFactory implements SchemeFactory {
    public ThriftCreditRequestInfoStandardScheme getScheme() {
      return new ThriftCreditRequestInfoStandardScheme();
    }
  }

  private static class ThriftCreditRequestInfoStandardScheme extends StandardScheme<ThriftCreditRequestInfo> {

    public void read(org.apache.thrift.protocol.TProtocol iprot, ThriftCreditRequestInfo struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TField schemeField;
      iprot.readStructBegin();
      while (true)
      {
        schemeField = iprot.readFieldBegin();
        if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
          break;
        }
        switch (schemeField.id) {
          case 1: // O_TYPE
            if (schemeField.type == org.apache.thrift.protocol.TType.I32) {
              struct.oType = jayeson.vodds.service.cms.thrift.ThriftOrderType.findByValue(iprot.readI32());
              struct.setOTypeIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 2: // T_TYPE
            if (schemeField.type == org.apache.thrift.protocol.TType.I32) {
              struct.tType = jayeson.vodds.service.cms.thrift.ThriftTransactionType.findByValue(iprot.readI32());
              struct.setTTypeIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 3: // SERVICE_ID
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.serviceId = iprot.readString();
              struct.setServiceIdIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 4: // USER_ID
            if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
              struct.userId = iprot.readI64();
              struct.setUserIdIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 5: // MATCH_ID
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.matchId = iprot.readString();
              struct.setMatchIdIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 6: // SPORT_TYPE
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.sportType = iprot.readString();
              struct.setSportTypeIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 7: // ORDER_STATUS
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.orderStatus = iprot.readString();
              struct.setOrderStatusIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 8: // EXECUTION_STAGE
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.executionStage = iprot.readString();
              struct.setExecutionStageIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 9: // START_TIME
            if (schemeField.type == org.apache.thrift.protocol.TType.I64) {
              struct.startTime = iprot.readI64();
              struct.setStartTimeIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 10: // ORIGINAL_STAKE
            if (schemeField.type == org.apache.thrift.protocol.TType.DOUBLE) {
              struct.originalStake = iprot.readDouble();
              struct.setOriginalStakeIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 11: // REQUEST_JSON
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.requestJson = iprot.readString();
              struct.setRequestJsonIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          default:
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      if (!struct.isSetUserId()) {
        throw new org.apache.thrift.protocol.TProtocolException("Required field 'userId' was not found in serialized data! Struct: " + toString());
      }
      if (!struct.isSetStartTime()) {
        throw new org.apache.thrift.protocol.TProtocolException("Required field 'startTime' was not found in serialized data! Struct: " + toString());
      }
      struct.validate();
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot, ThriftCreditRequestInfo struct) throws org.apache.thrift.TException {
      struct.validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (struct.oType != null) {
        oprot.writeFieldBegin(O_TYPE_FIELD_DESC);
        oprot.writeI32(struct.oType.getValue());
        oprot.writeFieldEnd();
      }
      if (struct.tType != null) {
        oprot.writeFieldBegin(T_TYPE_FIELD_DESC);
        oprot.writeI32(struct.tType.getValue());
        oprot.writeFieldEnd();
      }
      if (struct.serviceId != null) {
        oprot.writeFieldBegin(SERVICE_ID_FIELD_DESC);
        oprot.writeString(struct.serviceId);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldBegin(USER_ID_FIELD_DESC);
      oprot.writeI64(struct.userId);
      oprot.writeFieldEnd();
      if (struct.matchId != null) {
        oprot.writeFieldBegin(MATCH_ID_FIELD_DESC);
        oprot.writeString(struct.matchId);
        oprot.writeFieldEnd();
      }
      if (struct.sportType != null) {
        oprot.writeFieldBegin(SPORT_TYPE_FIELD_DESC);
        oprot.writeString(struct.sportType);
        oprot.writeFieldEnd();
      }
      if (struct.orderStatus != null) {
        oprot.writeFieldBegin(ORDER_STATUS_FIELD_DESC);
        oprot.writeString(struct.orderStatus);
        oprot.writeFieldEnd();
      }
      if (struct.executionStage != null) {
        oprot.writeFieldBegin(EXECUTION_STAGE_FIELD_DESC);
        oprot.writeString(struct.executionStage);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldBegin(START_TIME_FIELD_DESC);
      oprot.writeI64(struct.startTime);
      oprot.writeFieldEnd();
      oprot.writeFieldBegin(ORIGINAL_STAKE_FIELD_DESC);
      oprot.writeDouble(struct.originalStake);
      oprot.writeFieldEnd();
      if (struct.requestJson != null) {
        oprot.writeFieldBegin(REQUEST_JSON_FIELD_DESC);
        oprot.writeString(struct.requestJson);
        oprot.writeFieldEnd();
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

  }

  private static class ThriftCreditRequestInfoTupleSchemeFactory implements SchemeFactory {
    public ThriftCreditRequestInfoTupleScheme getScheme() {
      return new ThriftCreditRequestInfoTupleScheme();
    }
  }

  private static class ThriftCreditRequestInfoTupleScheme extends TupleScheme<ThriftCreditRequestInfo> {

    @Override
    public void write(org.apache.thrift.protocol.TProtocol prot, ThriftCreditRequestInfo struct) throws org.apache.thrift.TException {
      TTupleProtocol oprot = (TTupleProtocol) prot;
      oprot.writeI32(struct.oType.getValue());
      oprot.writeI32(struct.tType.getValue());
      oprot.writeString(struct.serviceId);
      oprot.writeI64(struct.userId);
      oprot.writeString(struct.matchId);
      oprot.writeString(struct.sportType);
      oprot.writeString(struct.orderStatus);
      oprot.writeI64(struct.startTime);
      oprot.writeString(struct.requestJson);
      BitSet optionals = new BitSet();
      if (struct.isSetExecutionStage()) {
        optionals.set(0);
      }
      if (struct.isSetOriginalStake()) {
        optionals.set(1);
      }
      oprot.writeBitSet(optionals, 2);
      if (struct.isSetExecutionStage()) {
        oprot.writeString(struct.executionStage);
      }
      if (struct.isSetOriginalStake()) {
        oprot.writeDouble(struct.originalStake);
      }
    }

    @Override
    public void read(org.apache.thrift.protocol.TProtocol prot, ThriftCreditRequestInfo struct) throws org.apache.thrift.TException {
      TTupleProtocol iprot = (TTupleProtocol) prot;
      struct.oType = jayeson.vodds.service.cms.thrift.ThriftOrderType.findByValue(iprot.readI32());
      struct.setOTypeIsSet(true);
      struct.tType = jayeson.vodds.service.cms.thrift.ThriftTransactionType.findByValue(iprot.readI32());
      struct.setTTypeIsSet(true);
      struct.serviceId = iprot.readString();
      struct.setServiceIdIsSet(true);
      struct.userId = iprot.readI64();
      struct.setUserIdIsSet(true);
      struct.matchId = iprot.readString();
      struct.setMatchIdIsSet(true);
      struct.sportType = iprot.readString();
      struct.setSportTypeIsSet(true);
      struct.orderStatus = iprot.readString();
      struct.setOrderStatusIsSet(true);
      struct.startTime = iprot.readI64();
      struct.setStartTimeIsSet(true);
      struct.requestJson = iprot.readString();
      struct.setRequestJsonIsSet(true);
      BitSet incoming = iprot.readBitSet(2);
      if (incoming.get(0)) {
        struct.executionStage = iprot.readString();
        struct.setExecutionStageIsSet(true);
      }
      if (incoming.get(1)) {
        struct.originalStake = iprot.readDouble();
        struct.setOriginalStakeIsSet(true);
      }
    }
  }

}

